/*
 * This file is generated by jOOQ.
 */
package com.alkemy.sophia.api.sophiamsinvoice.dbmodel.jooq.tables;


import com.alkemy.sophia.api.sophiamsinvoice.dbmodel.jooq.DefaultSchema;
import com.alkemy.sophia.api.sophiamsinvoice.dbmodel.jooq.Indexes;
import com.alkemy.sophia.api.sophiamsinvoice.dbmodel.jooq.Keys;
import com.alkemy.sophia.api.sophiamsinvoice.dbmodel.jooq.tables.records.MmBackclaimStatisticsRecord;

import java.math.BigDecimal;
import java.util.Arrays;
import java.util.List;

import javax.annotation.Generated;

import org.jooq.Field;
import org.jooq.ForeignKey;
import org.jooq.Identity;
import org.jooq.Index;
import org.jooq.Name;
import org.jooq.Record;
import org.jooq.Schema;
import org.jooq.Table;
import org.jooq.TableField;
import org.jooq.UniqueKey;
import org.jooq.impl.DSL;
import org.jooq.impl.TableImpl;


/**
 * This class is generated by jOOQ.
 */
@Generated(
    value = {
        "http://www.jooq.org",
        "jOOQ version:3.11.9"
    },
    comments = "This class is generated by jOOQ"
)
@SuppressWarnings({ "all", "unchecked", "rawtypes" })
public class MmBackclaimStatistics extends TableImpl<MmBackclaimStatisticsRecord> {

    private static final long serialVersionUID = 779930327;

    /**
     * The reference instance of <code>MM_BACKCLAIM_STATISTICS</code>
     */
    public static final MmBackclaimStatistics MM_BACKCLAIM_STATISTICS = new MmBackclaimStatistics();

    /**
     * The class holding records for this type
     */
    @Override
    public Class<MmBackclaimStatisticsRecord> getRecordType() {
        return MmBackclaimStatisticsRecord.class;
    }

    /**
     * The column <code>MM_BACKCLAIM_STATISTICS.ID</code>.
     */
    public final TableField<MmBackclaimStatisticsRecord, Long> ID = createField("ID", org.jooq.impl.SQLDataType.BIGINT.nullable(false).identity(true), this, "");

    /**
     * The column <code>MM_BACKCLAIM_STATISTICS.ID_DSR</code>.
     */
    public final TableField<MmBackclaimStatisticsRecord, String> ID_DSR = createField("ID_DSR", org.jooq.impl.SQLDataType.VARCHAR(1024).nullable(false), this, "");

    /**
     * The column <code>MM_BACKCLAIM_STATISTICS.TOTALE_VALORE</code>.
     */
    public final TableField<MmBackclaimStatisticsRecord, BigDecimal> TOTALE_VALORE = createField("TOTALE_VALORE", org.jooq.impl.SQLDataType.DECIMAL(32, 20), this, "");

    /**
     * The column <code>MM_BACKCLAIM_STATISTICS.TOTALE_UTILIZZAZIONI</code>.
     */
    public final TableField<MmBackclaimStatisticsRecord, BigDecimal> TOTALE_UTILIZZAZIONI = createField("TOTALE_UTILIZZAZIONI", org.jooq.impl.SQLDataType.DECIMAL(32, 20), this, "");

    /**
     * The column <code>MM_BACKCLAIM_STATISTICS.TOTALE_SUBSCRIPTION</code>.
     */
    public final TableField<MmBackclaimStatisticsRecord, BigDecimal> TOTALE_SUBSCRIPTION = createField("TOTALE_SUBSCRIPTION", org.jooq.impl.SQLDataType.DECIMAL(32, 20), this, "");

    /**
     * Create a <code>MM_BACKCLAIM_STATISTICS</code> table reference
     */
    public MmBackclaimStatistics() {
        this(DSL.name("MM_BACKCLAIM_STATISTICS"), null);
    }

    /**
     * Create an aliased <code>MM_BACKCLAIM_STATISTICS</code> table reference
     */
    public MmBackclaimStatistics(String alias) {
        this(DSL.name(alias), MM_BACKCLAIM_STATISTICS);
    }

    /**
     * Create an aliased <code>MM_BACKCLAIM_STATISTICS</code> table reference
     */
    public MmBackclaimStatistics(Name alias) {
        this(alias, MM_BACKCLAIM_STATISTICS);
    }

    private MmBackclaimStatistics(Name alias, Table<MmBackclaimStatisticsRecord> aliased) {
        this(alias, aliased, null);
    }

    private MmBackclaimStatistics(Name alias, Table<MmBackclaimStatisticsRecord> aliased, Field<?>[] parameters) {
        super(alias, null, aliased, parameters, DSL.comment(""));
    }

    public <O extends Record> MmBackclaimStatistics(Table<O> child, ForeignKey<O, MmBackclaimStatisticsRecord> key) {
        super(child, key, MM_BACKCLAIM_STATISTICS);
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public Schema getSchema() {
        return DefaultSchema.DEFAULT_SCHEMA;
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public List<Index> getIndexes() {
        return Arrays.<Index>asList(Indexes.MM_BACKCLAIM_STATISTICS_MM_BACKCLAIM_STATISTICS_ID_DSR_IDX, Indexes.MM_BACKCLAIM_STATISTICS_PRIMARY);
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public Identity<MmBackclaimStatisticsRecord, Long> getIdentity() {
        return Keys.IDENTITY_MM_BACKCLAIM_STATISTICS;
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public UniqueKey<MmBackclaimStatisticsRecord> getPrimaryKey() {
        return Keys.KEY_MM_BACKCLAIM_STATISTICS_PRIMARY;
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public List<UniqueKey<MmBackclaimStatisticsRecord>> getKeys() {
        return Arrays.<UniqueKey<MmBackclaimStatisticsRecord>>asList(Keys.KEY_MM_BACKCLAIM_STATISTICS_PRIMARY, Keys.KEY_MM_BACKCLAIM_STATISTICS_MM_BACKCLAIM_STATISTICS_ID_DSR_IDX);
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public MmBackclaimStatistics as(String alias) {
        return new MmBackclaimStatistics(DSL.name(alias), this);
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public MmBackclaimStatistics as(Name alias) {
        return new MmBackclaimStatistics(alias, this);
    }

    /**
     * Rename this table
     */
    @Override
    public MmBackclaimStatistics rename(String name) {
        return new MmBackclaimStatistics(DSL.name(name), null);
    }

    /**
     * Rename this table
     */
    @Override
    public MmBackclaimStatistics rename(Name name) {
        return new MmBackclaimStatistics(name, null);
    }
}
